<template>
  <creation-step
    :previous-step="{
      name: 'campus-campus_id-rides-id-select-pois',
      params: { campus_id: campus.id, id: ride.id }
    }"
    @submit="submit"
  >
    <template #form>
      <fieldset class="fields-box">
        <ec-field
          field-id="start"
          label="Date et heure de départ"
        >
          <input
            id="start"
            :value="formattedStart"
            disabled
            class="input"
          >
        </ec-field>

        <ec-field
          label="Lieu de départ"
          field-id="departure"
        >
          <input
            id="departure"
            :value="ride.departure.label"
            disabled
            class="input"
          >
        </ec-field>

        <ec-field
          label="Lieu d'arrivée"
          field-id="arrival"
        >
          <input
            id="arrival"
            :value="ride.arrival.label"
            disabled
            class="input"
          >
        </ec-field>

        <ec-field
          label="Nombre de passagers"
          field-id="passengersCount"
        >
          <input
            id="passengersCount"
            :value="ride.passengersCount"
            class="input"
            disabled
          >
        </ec-field>

        <ec-field
          field-id="luggages"
          label="Présence de bagages"
        >
          <input
            :value="ride.luggage ? 'Oui':'Non'"
            class="input"
            disabled
          >
        </ec-field>

        <ec-field
          v-if="ride.userComments"
          field-id="comments"
          label="Commentaires / motif"
        >
          {{ ride.userComments }}
        </ec-field>
      </fieldset>
      <form-button>
        Lancer la réservation
      </form-button>
    </template>
  </creation-step>
</template>

<script>
import { DateTime } from 'luxon';
import { CREATE } from '@fabnumdef/e-chauffeur_lib-vue/api/status/transitions';
import creationStep from '~/components/creation-step/generic.vue';
import formButton from '~/components/creation-step/form-button.vue';
import errorsManagement from '~/helpers/mixins/errors-management';
import { MASK } from '~/pages/campus/_campus_id/rides/_id';
import { generateTitles } from '~/store/context';
import init from '~/components/creation-step/mixins/init-component';

const TITLE = 'Confirmez vos informations pour lancer la demande de réservation';
const SUBTITLE = 'Une fois la demande faite, vous recevrez un SMS ou un e-mail de confirmation.';

export default {
  components: {
    formButton,
    creationStep,
  },
  mixins: [
    init(generateTitles(TITLE, SUBTITLE)),
    errorsManagement(),
  ],
  props: {
    campus: {
      type: Object,
      default: () => ({}),
    },
  },
  async asyncData({ $api, params }) {
    try {
      const { data: ride } = await $api.query('rides').setMask(MASK).get(params.id);
      return {
        ride,
      };
    } catch (e) {
      throw new Error(`Impossible de trouver ou accéder aux informations de la course "${params.id}"`);
    }
  },
  computed: {
    formattedStart() {
      return DateTime.fromISO(this.ride.start).toLocaleString(DateTime.DATETIME_MED);
    },
  },
  methods: {
    async submit() {
      this.handleCommonErrorsBehavior(async () => {
        await this.$api.query('rides')
          .setCampus(this.campus.id)
          .setMask(MASK)
          .mutate(this.ride.id, CREATE);
        this.$toast.success('Votre course a été créée avec succès');
        this.$router.push({ name: 'my-account-current-rides' });
      });
    },
  },
};
</script>
